################################################################################
##gsea.r
##2018-11-27 fgarcia@cipf.es
################################################################################


date ()
Sys.info ()[c("nodename", "user")]
commandArgs ()
rm (list = ls ())
R.version.string 
library (mdgsa); packageDescription ("mdgsa", fields = "Version") #
library(GO.db)

# load("gsea.results.RData")



##INPUTS
################################################################################

#list of all ranked genes
datos <- read.table("diffexp_t_results_ranked_t3_vs_wt.txt", sep = "\t", as.is = T)
head(datos)
tail (datos)
dim(datos)

#functional annotation
anot <- read.table ("mart_export_ensembl_gene94_gos.txt", header = TRUE, sep = "\t", quote = "",
                    colClasses = "character")
dim(anot)
anot[1:3,]

#checkings
table (duplicated (anot))
table (anot$Gene.stable.ID == "")
table (anot$GO.term.accession == "")
table (anot$GO.domain == "")

length (unique (anot$Gene.stable.ID))
length (unique (anot$GO.term.accession))
length (unique(anot$GO.domain))
table(anot$GO.domain)

anot <- anot[!(anot$Gene.stable.ID == ""),  ]
anot <- anot[!(anot$GO.term.accession == ""),  ]
anot <- anot[!(anot$GO.domain == ""),  ]

length (unique (anot$Gene.stable.ID))
length (unique (anot$GO.term.accession))
length (unique(anot$GO.domain))
table(anot$GO.domain)


anot.bp <- anot[anot[,3] == "biological_process", 1:2]
head(anot.bp)
dim(anot.bp)
table (duplicated (anot.bp))
anot.bp <- anot.bp[!duplicated (anot.bp),]
dim(anot.bp)
length (unique (anot.bp$Gene.stable.ID))
length (unique (anot.bp$GO.term.accession))
head(anot.bp)

#annotation to list object
an.bp <- annotMat2list(anot.bp)
head(an.bp)
length(an.bp)

#filtering funcitonal blocks
an2.bp <- annotFilter(an.bp, minBlockSize = 20, maxBlockSize = 500)



## GSEA  
################################################################################

head(datos)
rindex0 <- datos[,2] 
names (rindex0) <- datos[,1]
summary(rindex0)
##transform ranking index
rindex <- indexTransform (rindex0)
summary(rindex)
plot (rindex0, rindex)
hist (rindex0)


res0 <- uvGsa (index = rindex, annot = an2.bp, p.adjust.method = "BY")
head(res0)
res <- cbind (res0, pattern = uvPat (res0))
head(res)
table(res$pattern)
res[, "description"] <- getGOnames(rownames(res))
head(res)
sig.res.over <- res[res$pattern > 0, ]
sig.res.down <- res[res$pattern < 0, ]
head(sig.res.over)
head(sig.res.down)

save.image("gsea.results.RData")



###EXIT
warnings ()
sessionInfo ()
q ("no")
